#include <avr/io.h>
#include <util/delay.h>
#include <stdio.h>

#include "serial.h"
#include "spi.h"

#define	DEFAULT_BRIGHTNESS	128

int main(void)
{
init_printf();

printf("Init. SPI\n");
spi_init(1);
_delay_ms(1000);

spi_initcs(&SPI_DDR_DISPLAY,SPI_BIT_DISPLAY);
spi_initcs(&SPI_DDR_MATRIX,SPI_BIT_MATRIX);
spi_unselect(&SPI_PORT_DISPLAY,SPI_BIT_DISPLAY);
spi_unselect(&SPI_PORT_MATRIX,SPI_BIT_MATRIX);

printf("Start SPI Tests\n");




/**Tableaux à destinations des afficheurs 7 segments**/
// 0, 1, 2, 3, 4
//uint8_t display7Segments[5] = {0x3F, 0x06, 0x5B, 0x4F, 0x66};
// 6, 7, 8, 9, A, B
//uint8_t display7Segments[6] = {0x7D, 0x07, 0x7F, 0x6F, 0x77, 0x7C};
// A, B, C, D, E, F
//int8_t display7Segments[] = {0x77, 0x7C, 0x39, 0x5E, 0x79, 0x71};
// A, B, C, D, E, F
// Cependant, nous sélectionnons au préalable les afficheurs 5 puis 4, 3, 2, 1, 0
//ce qui affiche finalement F, E, D, C, B, A
int8_t display7Segments[] = {0x6D, 0x77, 0x66, 0x7C, 0x4F, 0x39, 0x5B, 0x5E, 0x06, 0x79, 0x3F, 0x71};

/**Tableaux à destinations de la matrice de LEDs**/
// B, O, N, J, O, U, R
uint8_t matrice[7] = {0x7C, 0x3F, 0x37, 0x1E, 0x3F, 0xFF, 0x33};


/**Fonctionnement séquentiel de la maquette**/
while(1){

    /*Permet l'envoie d'un tableau sur les afficheurs 7 segments*/
    spi_select(&SPI_PORT_DISPLAY,SPI_BIT_DISPLAY);//sélection du uC controlant les afficheurs 7 segments
    _delay_ms(5);
    for(int i=0;i<12;i++) //parcours du tableau pour l'envoie des valeurs
    {
      spi_exch(display7Segments[i]);
      _delay_ms(24); // un temps inférieur à 24 ms fait saturer la communication et décale les valeurs que l'on envoie
    }
    spi_unselect(&SPI_PORT_DISPLAY,SPI_BIT_DISPLAY); //déselection du uC
    _delay_ms(150);
    
    
    //Permet l'envoie d'un message sur la matrice de LEDs
    spi_select(&SPI_PORT_MATRIX,SPI_BIT_MATRIX);//sélection du uC controlant la matrice de LEDs
    _delay_ms(5);
    for(int i=0;i<7;i++) //parcours du tableau pour l'envoie du message
    {
      spi_exch(matrice[i]);
      _delay_ms(800); // temps permettant d'avoir le temps de lire correctement l'enchainement des caractères
    }
    spi_unselect(&SPI_PORT_MATRIX,SPI_BIT_MATRIX); //déselection du uC
    _delay_ms(150);
  }

return 0;
}


  /***
  char cpt[7];
  sprintf(cpt,"%06d",num);
  spi_select(&SPI_PORT_DISPLAY,SPI_BIT_DISPLAY);
					// Set brightness
  spi_exch(0x83); spi_exch(DEFAULT_BRIGHTNESS-10*(num%10)); _delay_ms(2);
  spi_exch(0x80); _delay_ms(2);		// Clear screen
  					// Set decimal point
  spi_exch(0x81); spi_exch(num%6); _delay_ms(2);
  for(i=0;i<6;i++){ spi_exch(cpt[i]); _delay_ms(2); }
  spi_unselect(&SPI_PORT_DISPLAY,SPI_BIT_DISPLAY);

  spi_select(&SPI_PORT_MATRIX,SPI_BIT_MATRIX);
  switch(num%4){
    case 0: picture=picture1; break;;
    case 1:
    case 3: picture=picture2; break;;
    case 2: picture=picture3; break;;
    default: picture=NULL; break;;
    }
  if(picture) for(i=0;i<64;i++){ spi_exch(picture[i]); _delay_ms(2); }
  spi_unselect(&SPI_PORT_MATRIX,SPI_BIT_MATRIX);
  _delay_ms(1000);
  num++;
  }
  ***/
